
_set_up:

;Lm317_controlled_by_DAC.c,26 :: 		void set_up() {
;Lm317_controlled_by_DAC.c,28 :: 		ANSEL = 0x04;      // Pin RA2 sets as analog input.
	MOVLW      4
	MOVWF      ANSEL+0
;Lm317_controlled_by_DAC.c,29 :: 		TRISA = 0x04;
	MOVLW      4
	MOVWF      TRISA+0
;Lm317_controlled_by_DAC.c,30 :: 		ADCON1 = 0x82;    // the Vref is Vcc.
	MOVLW      130
	MOVWF      ADCON1+0
;Lm317_controlled_by_DAC.c,31 :: 		ANSELH = 0;      // the rest of the pins set as digital Inputs or outputs.
	CLRF       ANSELH+0
;Lm317_controlled_by_DAC.c,32 :: 		C1ON_bit = 0;    // analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;Lm317_controlled_by_DAC.c,33 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;Lm317_controlled_by_DAC.c,34 :: 		TRISB0_bit=1;
	BSF        TRISB0_bit+0, BitPos(TRISB0_bit+0)
;Lm317_controlled_by_DAC.c,35 :: 		TRISB1_bit=1;
	BSF        TRISB1_bit+0, BitPos(TRISB1_bit+0)
;Lm317_controlled_by_DAC.c,36 :: 		TRISE0_bit=1;
	BSF        TRISE0_bit+0, BitPos(TRISE0_bit+0)
;Lm317_controlled_by_DAC.c,37 :: 		TRISE1_bit=1;
	BSF        TRISE1_bit+0, BitPos(TRISE1_bit+0)
;Lm317_controlled_by_DAC.c,38 :: 		TRISD = 0;
	CLRF       TRISD+0
;Lm317_controlled_by_DAC.c,39 :: 		PORTD = 0;
	CLRF       PORTD+0
;Lm317_controlled_by_DAC.c,40 :: 		ADC_Init();
	CALL       _ADC_Init+0
;Lm317_controlled_by_DAC.c,41 :: 		delay_us(100);
	MOVLW      33
	MOVWF      R13+0
L_set_up0:
	DECFSZ     R13+0, 1
	GOTO       L_set_up0
;Lm317_controlled_by_DAC.c,42 :: 		Lcd_Init(); // LCD display initialization
	CALL       _Lcd_Init+0
;Lm317_controlled_by_DAC.c,43 :: 		Lcd_Cmd(_LCD_CURSOR_OFF); // LCD command (cursor off)
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;Lm317_controlled_by_DAC.c,44 :: 		Lcd_Cmd(_LCD_CLEAR); // LCD command (clear LCD)
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;Lm317_controlled_by_DAC.c,45 :: 		text = "Voltage:";
	MOVLW      ?lstr1_Lm317_controlled_by_DAC+0
	MOVWF      _text+0
;Lm317_controlled_by_DAC.c,46 :: 		Lcd_Out(1,1,text);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;Lm317_controlled_by_DAC.c,47 :: 		text = "Scale:";
	MOVLW      ?lstr2_Lm317_controlled_by_DAC+0
	MOVWF      _text+0
;Lm317_controlled_by_DAC.c,48 :: 		Lcd_Out(2,4,text);
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;Lm317_controlled_by_DAC.c,49 :: 		}
L_end_set_up:
	RETURN
; end of _set_up

_Print:

;Lm317_controlled_by_DAC.c,50 :: 		void Print() {
;Lm317_controlled_by_DAC.c,53 :: 		voltage = adc_rd/10.240;
	MOVF       _adc_rd+0, 0
	MOVWF      R0+0
	MOVF       _adc_rd+1, 0
	MOVWF      R0+1
	CALL       _word2double+0
	MOVLW      10
	MOVWF      R4+0
	MOVLW      215
	MOVWF      R4+1
	MOVLW      35
	MOVWF      R4+2
	MOVLW      130
	MOVWF      R4+3
	CALL       _Div_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      _voltage+0
	MOVF       R0+1, 0
	MOVWF      _voltage+1
	MOVF       R0+2, 0
	MOVWF      _voltage+2
	MOVF       R0+3, 0
	MOVWF      _voltage+3
;Lm317_controlled_by_DAC.c,54 :: 		voltage = voltage*0.25;
	MOVLW      0
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVLW      0
	MOVWF      R4+2
	MOVLW      125
	MOVWF      R4+3
	CALL       _Mul_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      _voltage+0
	MOVF       R0+1, 0
	MOVWF      _voltage+1
	MOVF       R0+2, 0
	MOVWF      _voltage+2
	MOVF       R0+3, 0
	MOVWF      _voltage+3
;Lm317_controlled_by_DAC.c,55 :: 		FloatToStr(voltage, txt);
	MOVF       R0+0, 0
	MOVWF      FARG_FloatToStr_fnum+0
	MOVF       R0+1, 0
	MOVWF      FARG_FloatToStr_fnum+1
	MOVF       R0+2, 0
	MOVWF      FARG_FloatToStr_fnum+2
	MOVF       R0+3, 0
	MOVWF      FARG_FloatToStr_fnum+3
	MOVLW      _txt+0
	MOVWF      FARG_FloatToStr_str+0
	CALL       _FloatToStr+0
;Lm317_controlled_by_DAC.c,56 :: 		Lcd_Out(1,9,txt);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      9
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _txt+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;Lm317_controlled_by_DAC.c,58 :: 		Lcd_Chr(2,10,48+ch);
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      10
	MOVWF      FARG_Lcd_Chr_column+0
	MOVF       _scale+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;Lm317_controlled_by_DAC.c,59 :: 		}
L_end_Print:
	RETURN
; end of _Print

_main:

;Lm317_controlled_by_DAC.c,61 :: 		void main() {
;Lm317_controlled_by_DAC.c,62 :: 		set_up();
	CALL       _set_up+0
;Lm317_controlled_by_DAC.c,63 :: 		do  {
L_main1:
;Lm317_controlled_by_DAC.c,64 :: 		adc_rd= ADC_Get_Sample(2);
	MOVLW      2
	MOVWF      FARG_ADC_Get_Sample_channel+0
	CALL       _ADC_Get_Sample+0
	MOVF       R0+0, 0
	MOVWF      _adc_rd+0
	MOVF       R0+1, 0
	MOVWF      _adc_rd+1
;Lm317_controlled_by_DAC.c,65 :: 		Print();
	CALL       _Print+0
;Lm317_controlled_by_DAC.c,67 :: 		if(scale==0) aux=0;
	MOVF       _scale+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main4
	CLRF       _aux+0
L_main4:
;Lm317_controlled_by_DAC.c,68 :: 		if(scale==1) aux=1;
	MOVF       _scale+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main5
	MOVLW      1
	MOVWF      _aux+0
L_main5:
;Lm317_controlled_by_DAC.c,69 :: 		if(scale==2) aux=3;
	MOVF       _scale+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L_main6
	MOVLW      3
	MOVWF      _aux+0
L_main6:
;Lm317_controlled_by_DAC.c,70 :: 		if(scale==3) aux=5;
	MOVF       _scale+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_main7
	MOVLW      5
	MOVWF      _aux+0
L_main7:
;Lm317_controlled_by_DAC.c,71 :: 		if(scale==4) aux=15;
	MOVF       _scale+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L_main8
	MOVLW      15
	MOVWF      _aux+0
L_main8:
;Lm317_controlled_by_DAC.c,72 :: 		if(scale==5) aux=17;
	MOVF       _scale+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L_main9
	MOVLW      17
	MOVWF      _aux+0
L_main9:
;Lm317_controlled_by_DAC.c,73 :: 		if(scale==6) aux=51;
	MOVF       _scale+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L_main10
	MOVLW      51
	MOVWF      _aux+0
L_main10:
;Lm317_controlled_by_DAC.c,74 :: 		if(scale==7) aux=85;
	MOVF       _scale+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L_main11
	MOVLW      85
	MOVWF      _aux+0
L_main11:
;Lm317_controlled_by_DAC.c,75 :: 		if(scale==8) aux=127;
	MOVF       _scale+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L_main12
	MOVLW      127
	MOVWF      _aux+0
L_main12:
;Lm317_controlled_by_DAC.c,77 :: 		if (Button(&PORTB,0,1,0)) E2=0;      //if the button has been pushed
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main13
	CLRF       _E2+0
L_main13:
;Lm317_controlled_by_DAC.c,78 :: 		if (E2==0 && Button(&PORTB,0,1,1)){  //and after that the button is free
	MOVF       _E2+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main16
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main16
L__main36:
;Lm317_controlled_by_DAC.c,79 :: 		scale++;                         //increase scale.
	INCF       _scale+0, 1
;Lm317_controlled_by_DAC.c,80 :: 		if (scale>8) scale=0;
	MOVLW      128
	XORLW      8
	MOVWF      R0+0
	MOVLW      128
	XORWF      _scale+0, 0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main17
	CLRF       _scale+0
L_main17:
;Lm317_controlled_by_DAC.c,81 :: 		E2=1;
	MOVLW      1
	MOVWF      _E2+0
;Lm317_controlled_by_DAC.c,82 :: 		}
L_main16:
;Lm317_controlled_by_DAC.c,83 :: 		if (Button(&PORTB,1,1,0)) E3=0;      //if the button has been pushed
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main18
	CLRF       _E3+0
L_main18:
;Lm317_controlled_by_DAC.c,84 :: 		if (E3==0 && Button(&PORTB,1,1,1)){  //and after that the button is free
	MOVF       _E3+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main21
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main21
L__main35:
;Lm317_controlled_by_DAC.c,85 :: 		scale--;                         //decrase scale.
	DECF       _scale+0, 1
;Lm317_controlled_by_DAC.c,86 :: 		if (scale<0) scale=8;
	MOVLW      128
	XORWF      _scale+0, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main22
	MOVLW      8
	MOVWF      _scale+0
L_main22:
;Lm317_controlled_by_DAC.c,87 :: 		E3=1;
	MOVLW      1
	MOVWF      _E3+0
;Lm317_controlled_by_DAC.c,88 :: 		}
L_main21:
;Lm317_controlled_by_DAC.c,89 :: 		if (Button(&PORTE,0,1,0)) E0=0;      //if the button has been pushed
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main23
	CLRF       _E0+0
L_main23:
;Lm317_controlled_by_DAC.c,90 :: 		if (E0==0 && Button(&PORTE,0,1,1)){  //and after that the button is free
	MOVF       _E0+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main26
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main26
L__main34:
;Lm317_controlled_by_DAC.c,91 :: 		value = value+aux;                   //increase value.
	MOVF       _aux+0, 0
	ADDWF      _value+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      _value+0
;Lm317_controlled_by_DAC.c,92 :: 		if (value>255) value=0;
	MOVF       R1+0, 0
	SUBLW      255
	BTFSC      STATUS+0, 0
	GOTO       L_main27
	CLRF       _value+0
L_main27:
;Lm317_controlled_by_DAC.c,93 :: 		E0=1;
	MOVLW      1
	MOVWF      _E0+0
;Lm317_controlled_by_DAC.c,94 :: 		}
L_main26:
;Lm317_controlled_by_DAC.c,95 :: 		if (Button(&PORTE,1,1,0)) E1=0;      //if the button has been pushed
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main28
	CLRF       _E1+0
L_main28:
;Lm317_controlled_by_DAC.c,96 :: 		if (E1==0 && Button(&PORTE,1,1,1)){  //and after that the button is free
	MOVF       _E1+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main31
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main31
L__main33:
;Lm317_controlled_by_DAC.c,97 :: 		value = value-aux;              //decrease value.
	MOVF       _aux+0, 0
	SUBWF      _value+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      _value+0
;Lm317_controlled_by_DAC.c,98 :: 		if (value<0) value=255;
	MOVLW      0
	SUBWF      R1+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main32
	MOVLW      255
	MOVWF      _value+0
L_main32:
;Lm317_controlled_by_DAC.c,99 :: 		E1=1;
	MOVLW      1
	MOVWF      _E1+0
;Lm317_controlled_by_DAC.c,100 :: 		}
L_main31:
;Lm317_controlled_by_DAC.c,101 :: 		PORTD=value;                 // print the value in binary for the DAC0808
	MOVF       _value+0, 0
	MOVWF      PORTD+0
;Lm317_controlled_by_DAC.c,102 :: 		} while (1);
	GOTO       L_main1
;Lm317_controlled_by_DAC.c,103 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
