
_set_up:

;lm317_Controlled_by_MCP4161.c,26 :: 		void set_up() {
;lm317_Controlled_by_MCP4161.c,28 :: 		ANSEL = 0x04;      // Pin RA2 sets as analog input.
	MOVLW      4
	MOVWF      ANSEL+0
;lm317_Controlled_by_MCP4161.c,29 :: 		TRISA = 0x04;
	MOVLW      4
	MOVWF      TRISA+0
;lm317_Controlled_by_MCP4161.c,30 :: 		ADCON1 = 0x82;    // the Vref is Vcc.
	MOVLW      130
	MOVWF      ADCON1+0
;lm317_Controlled_by_MCP4161.c,31 :: 		ANSELH = 0;      // the rest of the pins set as digital Inputs or outputs.
	CLRF       ANSELH+0
;lm317_Controlled_by_MCP4161.c,32 :: 		C1ON_bit = 0;    // analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;lm317_Controlled_by_MCP4161.c,33 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;lm317_Controlled_by_MCP4161.c,34 :: 		TRISB0_bit=1;
	BSF        TRISB0_bit+0, BitPos(TRISB0_bit+0)
;lm317_Controlled_by_MCP4161.c,35 :: 		TRISB1_bit=1;
	BSF        TRISB1_bit+0, BitPos(TRISB1_bit+0)
;lm317_Controlled_by_MCP4161.c,36 :: 		TRISE0_bit=1;
	BSF        TRISE0_bit+0, BitPos(TRISE0_bit+0)
;lm317_Controlled_by_MCP4161.c,37 :: 		TRISE1_bit=1;
	BSF        TRISE1_bit+0, BitPos(TRISE1_bit+0)
;lm317_Controlled_by_MCP4161.c,38 :: 		TRISC = 0x14;
	MOVLW      20
	MOVWF      TRISC+0
;lm317_Controlled_by_MCP4161.c,39 :: 		ADC_Init();
	CALL       _ADC_Init+0
;lm317_Controlled_by_MCP4161.c,40 :: 		DigPot_CS = 1;
	BSF        RE2_bit+0, BitPos(RE2_bit+0)
;lm317_Controlled_by_MCP4161.c,41 :: 		DigPot_CS_Direction = 0;
	BCF        TRISE2_bit+0, BitPos(TRISE2_bit+0)
;lm317_Controlled_by_MCP4161.c,42 :: 		SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV16, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
	MOVLW      1
	MOVWF      FARG_SPI1_Init_Advanced_master+0
	CLRF       FARG_SPI1_Init_Advanced_data_sample+0
	CLRF       FARG_SPI1_Init_Advanced_clock_idle+0
	MOVLW      1
	MOVWF      FARG_SPI1_Init_Advanced_transmit_edge+0
	CALL       _SPI1_Init_Advanced+0
;lm317_Controlled_by_MCP4161.c,43 :: 		delay_us(100);
	MOVLW      33
	MOVWF      R13+0
L_set_up0:
	DECFSZ     R13+0, 1
	GOTO       L_set_up0
;lm317_Controlled_by_MCP4161.c,44 :: 		Lcd_Init(); // LCD display initialization
	CALL       _Lcd_Init+0
;lm317_Controlled_by_MCP4161.c,45 :: 		Lcd_Cmd(_LCD_CURSOR_OFF); // LCD command (cursor off)
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;lm317_Controlled_by_MCP4161.c,46 :: 		Lcd_Cmd(_LCD_CLEAR); // LCD command (clear LCD)
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;lm317_Controlled_by_MCP4161.c,47 :: 		text = "Voltage:";
	MOVLW      ?lstr1_lm317_Controlled_by_MCP4161+0
	MOVWF      _text+0
;lm317_Controlled_by_MCP4161.c,48 :: 		Lcd_Out(1,1,text);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;lm317_Controlled_by_MCP4161.c,49 :: 		text = "Scale:";
	MOVLW      ?lstr2_lm317_Controlled_by_MCP4161+0
	MOVWF      _text+0
;lm317_Controlled_by_MCP4161.c,50 :: 		Lcd_Out(2,4,text);
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;lm317_Controlled_by_MCP4161.c,51 :: 		}
L_end_set_up:
	RETURN
; end of _set_up

_Print:

;lm317_Controlled_by_MCP4161.c,52 :: 		void Print() {
;lm317_Controlled_by_MCP4161.c,55 :: 		voltage = adc_rd/10.240;
	MOVF       _adc_rd+0, 0
	MOVWF      R0+0
	MOVF       _adc_rd+1, 0
	MOVWF      R0+1
	CALL       _word2double+0
	MOVLW      10
	MOVWF      R4+0
	MOVLW      215
	MOVWF      R4+1
	MOVLW      35
	MOVWF      R4+2
	MOVLW      130
	MOVWF      R4+3
	CALL       _Div_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      _voltage+0
	MOVF       R0+1, 0
	MOVWF      _voltage+1
	MOVF       R0+2, 0
	MOVWF      _voltage+2
	MOVF       R0+3, 0
	MOVWF      _voltage+3
;lm317_Controlled_by_MCP4161.c,56 :: 		voltage = voltage*0.25;
	MOVLW      0
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVLW      0
	MOVWF      R4+2
	MOVLW      125
	MOVWF      R4+3
	CALL       _Mul_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      _voltage+0
	MOVF       R0+1, 0
	MOVWF      _voltage+1
	MOVF       R0+2, 0
	MOVWF      _voltage+2
	MOVF       R0+3, 0
	MOVWF      _voltage+3
;lm317_Controlled_by_MCP4161.c,57 :: 		FloatToStr(voltage, txt);
	MOVF       R0+0, 0
	MOVWF      FARG_FloatToStr_fnum+0
	MOVF       R0+1, 0
	MOVWF      FARG_FloatToStr_fnum+1
	MOVF       R0+2, 0
	MOVWF      FARG_FloatToStr_fnum+2
	MOVF       R0+3, 0
	MOVWF      FARG_FloatToStr_fnum+3
	MOVLW      _txt+0
	MOVWF      FARG_FloatToStr_str+0
	CALL       _FloatToStr+0
;lm317_Controlled_by_MCP4161.c,58 :: 		Lcd_Out(1,9,txt);
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      9
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _txt+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;lm317_Controlled_by_MCP4161.c,60 :: 		Lcd_Chr(2,10,48+ch);
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      10
	MOVWF      FARG_Lcd_Chr_column+0
	MOVF       _scale+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;lm317_Controlled_by_MCP4161.c,61 :: 		}
L_end_Print:
	RETURN
; end of _Print

_main:

;lm317_Controlled_by_MCP4161.c,63 :: 		void main() {
;lm317_Controlled_by_MCP4161.c,64 :: 		set_up();
	CALL       _set_up+0
;lm317_Controlled_by_MCP4161.c,65 :: 		Delay_ms(100);
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_main1:
	DECFSZ     R13+0, 1
	GOTO       L_main1
	DECFSZ     R12+0, 1
	GOTO       L_main1
	NOP
	NOP
;lm317_Controlled_by_MCP4161.c,66 :: 		do  {
L_main2:
;lm317_Controlled_by_MCP4161.c,67 :: 		adc_rd= ADC_Get_Sample(2);
	MOVLW      2
	MOVWF      FARG_ADC_Get_Sample_channel+0
	CALL       _ADC_Get_Sample+0
	MOVF       R0+0, 0
	MOVWF      _adc_rd+0
	MOVF       R0+1, 0
	MOVWF      _adc_rd+1
;lm317_Controlled_by_MCP4161.c,68 :: 		DigPot_CS = 0;                       // Select PotentioMeter chip
	BCF        RE2_bit+0, BitPos(RE2_bit+0)
;lm317_Controlled_by_MCP4161.c,69 :: 		SPI1_Write(0);
	CLRF       FARG_SPI1_Write_data_+0
	CALL       _SPI1_Write+0
;lm317_Controlled_by_MCP4161.c,70 :: 		SPI1_Write(value);
	MOVF       _value+0, 0
	MOVWF      FARG_SPI1_Write_data_+0
	CALL       _SPI1_Write+0
;lm317_Controlled_by_MCP4161.c,72 :: 		SPI1_Write(0x20);
	MOVLW      32
	MOVWF      FARG_SPI1_Write_data_+0
	CALL       _SPI1_Write+0
;lm317_Controlled_by_MCP4161.c,73 :: 		SPI1_Write(value);
	MOVF       _value+0, 0
	MOVWF      FARG_SPI1_Write_data_+0
	CALL       _SPI1_Write+0
;lm317_Controlled_by_MCP4161.c,74 :: 		DigPot_CS = 1;                       // Deselect PotentioMeter chip
	BSF        RE2_bit+0, BitPos(RE2_bit+0)
;lm317_Controlled_by_MCP4161.c,76 :: 		Print();
	CALL       _Print+0
;lm317_Controlled_by_MCP4161.c,78 :: 		if(scale==0) aux=0;
	MOVF       _scale+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main5
	CLRF       _aux+0
L_main5:
;lm317_Controlled_by_MCP4161.c,79 :: 		if(scale==1) aux=1;
	MOVF       _scale+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main6
	MOVLW      1
	MOVWF      _aux+0
L_main6:
;lm317_Controlled_by_MCP4161.c,80 :: 		if(scale==2) aux=3;
	MOVF       _scale+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L_main7
	MOVLW      3
	MOVWF      _aux+0
L_main7:
;lm317_Controlled_by_MCP4161.c,81 :: 		if(scale==3) aux=5;
	MOVF       _scale+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_main8
	MOVLW      5
	MOVWF      _aux+0
L_main8:
;lm317_Controlled_by_MCP4161.c,82 :: 		if(scale==4) aux=15;
	MOVF       _scale+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L_main9
	MOVLW      15
	MOVWF      _aux+0
L_main9:
;lm317_Controlled_by_MCP4161.c,83 :: 		if(scale==5) aux=17;
	MOVF       _scale+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L_main10
	MOVLW      17
	MOVWF      _aux+0
L_main10:
;lm317_Controlled_by_MCP4161.c,84 :: 		if(scale==6) aux=51;
	MOVF       _scale+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L_main11
	MOVLW      51
	MOVWF      _aux+0
L_main11:
;lm317_Controlled_by_MCP4161.c,85 :: 		if(scale==7) aux=85;
	MOVF       _scale+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L_main12
	MOVLW      85
	MOVWF      _aux+0
L_main12:
;lm317_Controlled_by_MCP4161.c,86 :: 		if(scale==8) aux=127;
	MOVF       _scale+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L_main13
	MOVLW      127
	MOVWF      _aux+0
L_main13:
;lm317_Controlled_by_MCP4161.c,88 :: 		if (Button(&PORTB,0,1,0)) E2=0;      //if the button has been pushed
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main14
	CLRF       _E2+0
L_main14:
;lm317_Controlled_by_MCP4161.c,89 :: 		if (E2==0 && Button(&PORTB,0,1,1)){  //and after that the button is free
	MOVF       _E2+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main17
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main17
L__main37:
;lm317_Controlled_by_MCP4161.c,90 :: 		scale++;                         //increase scale.
	INCF       _scale+0, 1
;lm317_Controlled_by_MCP4161.c,91 :: 		if (scale>8) scale=0;
	MOVLW      128
	XORLW      8
	MOVWF      R0+0
	MOVLW      128
	XORWF      _scale+0, 0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main18
	CLRF       _scale+0
L_main18:
;lm317_Controlled_by_MCP4161.c,92 :: 		E2=1;
	MOVLW      1
	MOVWF      _E2+0
;lm317_Controlled_by_MCP4161.c,93 :: 		}
L_main17:
;lm317_Controlled_by_MCP4161.c,94 :: 		if (Button(&PORTB,1,1,0)) E3=0;      //if the button has been pushed
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main19
	CLRF       _E3+0
L_main19:
;lm317_Controlled_by_MCP4161.c,95 :: 		if (E3==0 && Button(&PORTB,1,1,1)){  //and after that the button is free
	MOVF       _E3+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main22
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main22
L__main36:
;lm317_Controlled_by_MCP4161.c,96 :: 		scale--;                         //decrase scale.
	DECF       _scale+0, 1
;lm317_Controlled_by_MCP4161.c,97 :: 		if (scale<0) scale=8;
	MOVLW      128
	XORWF      _scale+0, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main23
	MOVLW      8
	MOVWF      _scale+0
L_main23:
;lm317_Controlled_by_MCP4161.c,98 :: 		E3=1;
	MOVLW      1
	MOVWF      _E3+0
;lm317_Controlled_by_MCP4161.c,99 :: 		}
L_main22:
;lm317_Controlled_by_MCP4161.c,100 :: 		if (Button(&PORTE,0,1,0)) E0=0;      //if the button has been pushed
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main24
	CLRF       _E0+0
L_main24:
;lm317_Controlled_by_MCP4161.c,101 :: 		if (E0==0 && Button(&PORTE,0,1,1)){  //and after that the button is free
	MOVF       _E0+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main27
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main27
L__main35:
;lm317_Controlled_by_MCP4161.c,102 :: 		value = value+aux;                   //increase value.
	MOVF       _aux+0, 0
	ADDWF      _value+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      _value+0
;lm317_Controlled_by_MCP4161.c,103 :: 		if (value>255) value=0;
	MOVF       R1+0, 0
	SUBLW      255
	BTFSC      STATUS+0, 0
	GOTO       L_main28
	CLRF       _value+0
L_main28:
;lm317_Controlled_by_MCP4161.c,104 :: 		E0=1;
	MOVLW      1
	MOVWF      _E0+0
;lm317_Controlled_by_MCP4161.c,105 :: 		}
L_main27:
;lm317_Controlled_by_MCP4161.c,106 :: 		if (Button(&PORTE,1,1,0)) E1=0;      //if the button has been pushed
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main29
	CLRF       _E1+0
L_main29:
;lm317_Controlled_by_MCP4161.c,107 :: 		if (E1==0 && Button(&PORTE,1,1,1)){  //and after that the button is free
	MOVF       _E1+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main32
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main32
L__main34:
;lm317_Controlled_by_MCP4161.c,108 :: 		value = value-aux;              //decrease value.
	MOVF       _aux+0, 0
	SUBWF      _value+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      _value+0
;lm317_Controlled_by_MCP4161.c,109 :: 		if (value<0) value=255;
	MOVLW      0
	SUBWF      R1+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main33
	MOVLW      255
	MOVWF      _value+0
L_main33:
;lm317_Controlled_by_MCP4161.c,110 :: 		E1=1;
	MOVLW      1
	MOVWF      _E1+0
;lm317_Controlled_by_MCP4161.c,111 :: 		}
L_main32:
;lm317_Controlled_by_MCP4161.c,113 :: 		} while (1);
	GOTO       L_main2
;lm317_Controlled_by_MCP4161.c,114 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
