
_set_up:

;FLCCD.c,6 :: 		void set_up() {
;FLCCD.c,8 :: 		ANSEL = 0;             // set the rest of pins as digital inputs or outputs.
	CLRF       ANSEL+0
;FLCCD.c,9 :: 		ANSELH = 0;
	CLRF       ANSELH+0
;FLCCD.c,10 :: 		C1ON_bit = 0;          // analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;FLCCD.c,11 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;FLCCD.c,12 :: 		TRISC2_bit=0;          //RC2 was configured as digital output.
	BCF        TRISC2_bit+0, BitPos(TRISC2_bit+0)
;FLCCD.c,13 :: 		TRISA5_bit=1;          //RA5 was configured as digital intput.
	BSF        TRISA5_bit+0, BitPos(TRISA5_bit+0)
;FLCCD.c,14 :: 		TRISE0_bit=1;         // RE0 and RE1 were configured as digital input.
	BSF        TRISE0_bit+0, BitPos(TRISE0_bit+0)
;FLCCD.c,15 :: 		TRISE1_bit=1;
	BSF        TRISE1_bit+0, BitPos(TRISE1_bit+0)
;FLCCD.c,16 :: 		TRISE2_bit=1;
	BSF        TRISE2_bit+0, BitPos(TRISE2_bit+0)
;FLCCD.c,17 :: 		TRISB=0;
	CLRF       TRISB+0
;FLCCD.c,18 :: 		PORTB=0;
	CLRF       PORTB+0
;FLCCD.c,19 :: 		PWM1_Init(2000);     //Frequency 2KHz.
	BSF        T2CON+0, 0
	BCF        T2CON+0, 1
	MOVLW      124
	MOVWF      PR2+0
	CALL       _PWM1_Init+0
;FLCCD.c,20 :: 		PWM1_Start();
	CALL       _PWM1_Start+0
;FLCCD.c,21 :: 		}
L_end_set_up:
	RETURN
; end of _set_up

_main:

;FLCCD.c,23 :: 		void main() {
;FLCCD.c,24 :: 		set_up();
	CALL       _set_up+0
;FLCCD.c,26 :: 		while (1){
L_main0:
;FLCCD.c,28 :: 		if(escala==0) divisor=0;
	MOVF       _escala+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main2
	CLRF       _divisor+0
L_main2:
;FLCCD.c,29 :: 		if(escala==1) divisor=1;
	MOVF       _escala+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main3
	MOVLW      1
	MOVWF      _divisor+0
L_main3:
;FLCCD.c,30 :: 		if(escala==2) divisor=3;
	MOVF       _escala+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L_main4
	MOVLW      3
	MOVWF      _divisor+0
L_main4:
;FLCCD.c,31 :: 		if(escala==3) divisor=5;
	MOVF       _escala+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_main5
	MOVLW      5
	MOVWF      _divisor+0
L_main5:
;FLCCD.c,32 :: 		if(escala==4) divisor=15;
	MOVF       _escala+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L_main6
	MOVLW      15
	MOVWF      _divisor+0
L_main6:
;FLCCD.c,33 :: 		if(escala==5) divisor=17;
	MOVF       _escala+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L_main7
	MOVLW      17
	MOVWF      _divisor+0
L_main7:
;FLCCD.c,34 :: 		if(escala==6) divisor=51;
	MOVF       _escala+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L_main8
	MOVLW      51
	MOVWF      _divisor+0
L_main8:
;FLCCD.c,35 :: 		if(escala==7) divisor=85;
	MOVF       _escala+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L_main9
	MOVLW      85
	MOVWF      _divisor+0
L_main9:
;FLCCD.c,36 :: 		if(escala==8) divisor=127;
	MOVF       _escala+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L_main10
	MOVLW      127
	MOVWF      _divisor+0
L_main10:
;FLCCD.c,38 :: 		PORTB = display[escala];
	MOVF       _escala+0, 0
	ADDLW      _display+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      PORTB+0
;FLCCD.c,40 :: 		if (Button(&PORTE,2,1,0)) E2=0;      //if the button has been pushed
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	MOVLW      2
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main11
	CLRF       _E2+0
L_main11:
;FLCCD.c,41 :: 		if (E2==0 && Button(&PORTE,2,1,1)){  //and after that the button is free
	MOVF       _E2+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main14
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	MOVLW      2
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main14
L__main35:
;FLCCD.c,42 :: 		escala++;
	INCF       _escala+0, 1
;FLCCD.c,43 :: 		if (escala>8) escala=0;
	MOVLW      128
	XORLW      8
	MOVWF      R0+0
	MOVLW      128
	XORWF      _escala+0, 0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main15
	CLRF       _escala+0
L_main15:
;FLCCD.c,44 :: 		E2=1;
	MOVLW      1
	MOVWF      _E2+0
;FLCCD.c,45 :: 		}
L_main14:
;FLCCD.c,46 :: 		if (Button(&PORTA,5,1,0)) E3=0;      //if the button has been pushed
	MOVLW      PORTA+0
	MOVWF      FARG_Button_port+0
	MOVLW      5
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main16
	CLRF       _E3+0
L_main16:
;FLCCD.c,47 :: 		if (E3==0 && Button(&PORTA,5,1,1)){  //and after that the button is free
	MOVF       _E3+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main19
	MOVLW      PORTA+0
	MOVWF      FARG_Button_port+0
	MOVLW      5
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main19
L__main34:
;FLCCD.c,48 :: 		escala--;
	DECF       _escala+0, 1
;FLCCD.c,49 :: 		if (escala<0) escala=8;
	MOVLW      128
	XORWF      _escala+0, 0
	MOVWF      R0+0
	MOVLW      128
	XORLW      0
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main20
	MOVLW      8
	MOVWF      _escala+0
L_main20:
;FLCCD.c,50 :: 		E3=1;
	MOVLW      1
	MOVWF      _E3+0
;FLCCD.c,51 :: 		}
L_main19:
;FLCCD.c,52 :: 		if (Button(&PORTE,0,1,0)) E0=0;      //if the button has been pushed
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main21
	CLRF       _E0+0
L_main21:
;FLCCD.c,53 :: 		if (E0==0 && Button(&PORTE,0,1,1)){  //and after that the button is free
	MOVF       _E0+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main24
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main24
L__main33:
;FLCCD.c,54 :: 		duty=duty+divisor;                         //increase temp1.
	MOVF       _divisor+0, 0
	ADDWF      _duty+0, 0
	MOVWF      R1+0
	MOVF       _duty+1, 0
	BTFSC      STATUS+0, 0
	ADDLW      1
	MOVWF      R1+1
	MOVLW      0
	BTFSC      _divisor+0, 7
	MOVLW      255
	ADDWF      R1+1, 1
	MOVF       R1+0, 0
	MOVWF      _duty+0
	MOVF       R1+1, 0
	MOVWF      _duty+1
;FLCCD.c,55 :: 		if (duty>255) duty=255;
	MOVLW      128
	MOVWF      R0+0
	MOVLW      128
	XORWF      R1+1, 0
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main38
	MOVF       R1+0, 0
	SUBLW      255
L__main38:
	BTFSC      STATUS+0, 0
	GOTO       L_main25
	MOVLW      255
	MOVWF      _duty+0
	CLRF       _duty+1
L_main25:
;FLCCD.c,56 :: 		E0=1;
	MOVLW      1
	MOVWF      _E0+0
;FLCCD.c,57 :: 		}
L_main24:
;FLCCD.c,58 :: 		if (Button(&PORTE,1,1,0)) E1=0;      //if the button has been pushed
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main26
	CLRF       _E1+0
L_main26:
;FLCCD.c,59 :: 		if (E1==0 && Button(&PORTE,1,1,1)){  //and after that the button is free
	MOVF       _E1+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main29
	MOVLW      PORTE+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      1
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main29
L__main32:
;FLCCD.c,60 :: 		duty=duty-divisor;               //increase temp1.
	MOVF       _divisor+0, 0
	SUBWF      _duty+0, 0
	MOVWF      R1+0
	MOVLW      0
	BTFSC      _divisor+0, 7
	MOVLW      255
	BTFSS      STATUS+0, 0
	ADDLW      1
	SUBWF      _duty+1, 0
	MOVWF      R1+1
	MOVF       R1+0, 0
	MOVWF      _duty+0
	MOVF       R1+1, 0
	MOVWF      _duty+1
;FLCCD.c,61 :: 		if (duty<0) duty=0;
	MOVLW      128
	XORWF      R1+1, 0
	MOVWF      R0+0
	MOVLW      128
	SUBWF      R0+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main39
	MOVLW      0
	SUBWF      R1+0, 0
L__main39:
	BTFSC      STATUS+0, 0
	GOTO       L_main30
	CLRF       _duty+0
	CLRF       _duty+1
L_main30:
;FLCCD.c,62 :: 		E1=1;
	MOVLW      1
	MOVWF      _E1+0
;FLCCD.c,63 :: 		}
L_main29:
;FLCCD.c,64 :: 		PWM1_Set_Duty(duty);
	MOVF       _duty+0, 0
	MOVWF      FARG_PWM1_Set_Duty_new_duty+0
	CALL       _PWM1_Set_Duty+0
;FLCCD.c,65 :: 		delay_ms(1);
	MOVLW      2
	MOVWF      R12+0
	MOVLW      75
	MOVWF      R13+0
L_main31:
	DECFSZ     R13+0, 1
	GOTO       L_main31
	DECFSZ     R12+0, 1
	GOTO       L_main31
;FLCCD.c,66 :: 		}
	GOTO       L_main0
;FLCCD.c,67 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
